<?php
namespace app\workerapi\lists;

use app\common\model\works\IssueWork;
use app\common\lists\ListsSearchInterface;


/**
 * IssueWork列表
 * Class IssueWorkLists
 * @package app\workerapi\listsworks
 */
class IssueWorkLists extends BaseWorkerDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author whitef
     * @date 2024/07/10 15:06
     */
    public function setSearch(): array
    {
        return [
            '=' => ['work_sn', 'service_work_id', 'complaint_status', 'responsible', 'complaint_details', 'finished_time', 'approval_admin_id', 'approval_time', 'create_time', 'update_time'],
        ];
    }

    public function querySearch(): array
    {
        $where['master_worker_id'] = ['=',$this->userId];
        return $where;
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author whitef
     * @date 2024/07/10 15:06
     */
    public function lists(): array
    {
        return IssueWork::with(['service_work'=>function ($query) {
            $query->field(['id', 'work_sn', 'address', 'title', 'work_status', 'service_status', 'work_pay_status','appointment_time','receive_time','base_service_fee','service_fee'])->append(['work_status_text','service_status_text']);
        }])
        ->where($this->searchWhere)
            ->where($this->querySearch())
            ->where('issue_approval','>',0)
            ->field(['id', 'work_sn', 'service_work_id', 'issue_approval', 'complaint_status', 'responsible', 'complaint_details', 'complaint_images', 'finished_time', 'create_time', 'update_time'])
            ->append(['issue_approval_text'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }

    /**
     * @notes 获取数量
     * @return int
     * @author whitef
     * @date 2024/07/10 15:06
     */
    public function count(): int
    {
        return IssueWork::where($this->searchWhere)->where($this->querySearch())->where('issue_approval','>',0)->count();
    }

}